<?php
// PHP Site/Server Status Monitor
// NOTE: Requires PHP version 5 or later for smtp
// Author: Eastwood Arts
// Website: http://eastwoodarts.com/

// The basis for this script was originally published by Sam Critchley on 2005-10-25
// See http://blog.a2b.cc for more details.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.


// comment this out if you need to debug
//error_reporting(0);

##### Config stuff #####

// The name of the database
define('DB_NAME', 'database_name');

// MySQL database username
define('DB_USER', 'database_user');

// MySQL database password
define('DB_PASSWORD', 'password');

// MySQL hostname
define('DB_HOST', 'localhost');

// Select whether you want to send a ping or a socket connection using fsockopen
// Depending on your server configuration you may not be able to use the exec() function
// Values are 'ping' or 'fsockopen'
define('PING', 'ping');

// Define the interval in minutes between downtime alerts
define('ALERT_INT', 10);

// Select whether you want to use mail (PHP mail() function) or smtp (using PHPMailer)
// Values are 'mail' or 'smtp'
define('MAILER', 'mail');

// Enable SMTP authentication
// For gmail set this to true
define('SMTPAUTH', true);

// Sets the prefix to the server
// Leave blank for default. For gmail set to 'ssl'.
define('SMTPSECURE', 'ssl');

// SMTP host
define('SMTP_HOST', 'smtp.example.com');

// SMTP port
// 25 for most. 465 for gmail.
define('SMTP_PORT', 25);

// SMTP username and password. Leave blank if none.
define('SMTP_USERNAME', 'myaddress@example.com');
define('SMTP_PASSWORD', 'password');

// From name for outgoing messages
define('FROM_NAME', 'Site status monitor');

// From email for outgoing messages
define('FROM_EMAIL', 'myaddress@example.com');


##### Doing Stuff #####

// Connect to the MySQL server
$db_connection = @mysql_connect (DB_HOST, DB_USER, DB_PASSWORD) or die ('Could not connect to the MySQL server sorry: ' . mysql_error());

// Select the right database
mysql_select_db (DB_NAME) or die ('Could not select the database: ' . mysql_error());

// Work out the variables from the arguments on the command line
// First get the -h, -l and -e arguments from the command issued
// and put them into an array call $getoptarray
$getoptarray = getopt("h:l:e:");

// Then derive the pinged hostname, the source machine, and the email address
// to send a warning mail to, from the argument-derived variables
$hostname = $getoptarray["h"];
$localhost = $getoptarray["l"];
$monitoremailaddress = $getoptarray["e"];

// ping the domain
switch (constant("PING")) {
	case 'ping':
		
		// Now run an exec command to ping the hostname and grab the output
		$str = exec("ping -c 1 -w 1 $hostname",$a,$a1);
		
		// If there's some output from the ping command then the ping has succeeded
		if (strlen($str) != -1) {
			$str = true;
		} else {
			$str = false;
		}
		
		break;
		
	case 'fsockopen':

		// Function to check response time using fsockopen()
		function socket_ping($domain){
			$starttime = microtime(true);
			$file      = fsockopen ($domain, 80, $errno, $errstr, 10);
			$stoptime  = microtime(true);
			$status    = 0;

			if (!$file) $status = -1;  // Site is down
			else {
				fclose($file);
				$status = ($stoptime - $starttime) * 1000;
				$status = floor($status);
			}
			return $status;
		}
		
		// Run the function to record the socket connection output
		$str = socket_ping($hostname);
		
		// Look at the output to see if the socket connection succeeded
		if ($str != -1) {
			$str = true;
		} else {
			$str = false;
		}
		
		break;
		
	default:
	
		exit('The \'Ping\' type is not set correctly.');
		
}

// If the ping or socket connection has succeeded
if ($str) {

     // Ping response has been received, therefore can update the database record to set
     // mon_host_ping_factor back to 0
     // The script uses a database table called mon_host_ping and has columns
     // mon_host_ping_hostname = hostname of the host to be pinged
     // mon_host_ping_factor = number of times in a row host has been pinged unsuccessfully
     // This database query sets mon_host_ping_factor to 0 if there's a successful ping
     $query = "UPDATE mon_host_ping SET mon_host_ping_factor = 0 WHERE mon_host_ping_hostname = '".mysql_real_escape_string($hostname)."'";
     $query_db = mysql_query($query, $db_connection) or die("Could not run the SQL Query");

// If there is no output from the ping command then the ping has not succeeded
// and you should generate an alarm mail if it hasn't succeeded for 10 minutes
// or 25 minutes (alter these values to suit)
} else {

	// Generate a database query adding 1 to mon_host_ping_factor if the ping is
	// unsuccessful
	$query2 = "UPDATE mon_host_ping SET mon_host_ping_factor = mon_host_ping_factor+1 WHERE mon_host_ping_hostname = '".mysql_real_escape_string($hostname)."'";
	$query_db2 = mysql_query($query2, $db_connection) or die("Could not run the SQL Query");

	// Now go and grab the mon_host_ping_factor back again, and send a mail if
	// it's equal to 10 or 25 (minutes assuming you're running this script on a
	// cron job every 1 minute)

	// Generate a MySQL query to work out what mon_host_ping_factor is
	$query3 = "SELECT * FROM mon_host_ping WHERE mon_host_ping_hostname = '".mysql_real_escape_string($hostname)."'";
	$query_db3=mysql_query($query3, $db_connection) or die("Could not run the SQL Query");
	// and then put the result into an array
	$row = @mysql_fetch_object($query_db3);
	// And put the mon_host_ping_factor into a variable
	$hostfactor = $row->mon_host_ping_factor;

	// grab the alert interval
	if (is_numeric(constant("ALERT_INT"))) {
		$alert_int = constant("ALERT_INT");
	} else {
		$alert_int = 10;
	}
	
	// Now send an alert email to the address specified in the command line if
	// the ping has been unsuccessful 10 or 25 minutes in a row
	if (($hostfactor >= $alert_int) and ($hostfactor % $alert_int == 0)) {
	
		// Set the subject of the message
		$subject = "ALERT - $hostname unpingable from $localhost for $hostfactor min";
		
		// Set the body of the message
		$message = "$hostname unpingable at ".date("H:i:s Y-m-d");
		
		// Get the address to which the email will be sent from the command line variable
		$sendto_addresses = $monitoremailaddress;
	
		// send emails
		switch (constant("MAILER")) {
			case 'mail':
				
				// Now set the headers to be added to the email
				$headers .= "MIME-Version: 1.0\r\n";
				$headers .= "Content-type: text/html; charset=iso-8859-1\r\n";
				$headers .= "From: ".constant("FROM_NAME")." < ".constant("FROM_EMAIL").">\r\n";
				$headers .= "X-Mailer: My Service Mailserv";
				
				// Now use the PHP mail() function to send the email to the recipient(s)
				mail($sendto_addresses, $subject, $message, $headers);
				
				break;
				
			case 'smtp':
				
				// using PHPMailer to handle smtp messages
				// see http://phpmailer.worxware.com/ for more info
				include("phpmailer/class.phpmailer.php");
				
				$mail = new PHPMailer();
				$mail->IsSMTP();
				$mail->SMTPAuth	= constant("SMTPAUTH");		// enable SMTP authentication
				$mail->SMTPSecure = constant("SMTPSECURE");	// sets the prefix to the servier
				$mail->Host = constant("SMTP_HOST");		// sets the SMTP server
				$mail->Port = constant("SMTP_PORT");		// set the SMTP port for the server
				
				$mail->Username   = constant("SMTP_USERNAME");
				$mail->Password   = constant("SMTP_PASSWORD");
				
				$mail->IsHTML(false);	// send as HTML or not
				
				// break down email address list and add to BCC
				$addresses_array = explode(",", $sendto_addresses);
				foreach ($addresses_array as $value) {
					$mail->AddBCC($value);
				}
				
				$mail->From = constant("FROM_EMAIL");
				$mail->FromName = constant("FROM_NAME");
				$mail->Subject = $subject;				
				$mail->Body = $message;
				
				// send it
				if(!$mail->Send()) {
					echo "Mailer Error: " . $mail->ErrorInfo;
				} else {
					//echo "Message has been sent";
				}
				
				break;
				
			default:
			
				exit('The mailing type is not set correctly.');
				
		}

	}
}
  
##### The End #####

?>
